Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package interpreter

  The main REPL related classes and values are as follows.

  The main REPL related classes and values are as follows. In addition to standard compiler classes Global and Settings, there are:

  History: an interface for session history. Completion: an interface for tab completion. ILoop (formerly InterpreterLoop): The umbrella class for a session. IMain (formerly Interpreter): Handles the evolving state of the session and handles submitting code to the compiler and handling the output. InteractiveReader: how ILoop obtains input. History: an interface for session history. Completion: an interface for tab completion. Power: a repository for more advanced/experimental features.

  ILoop contains { in: InteractiveReader, intp: IMain, settings: Settings, power: Power } InteractiveReader contains { history: History, completion: Completion } IMain contains { global: Global }

  Definition Classes
    nsc
-  class IMain extends Imports with PresentationCompilation

  An interpreter for Scala code.

  An interpreter for Scala code.

  The main public entry points are compile(), interpret(), and bind(). The compile() method loads a complete Scala file. The interpret() method executes one line of Scala code at the request of the user. The bind() method binds an object to a variable that can then be used by later interpreted code.

  The overall approach is based on compiling the requested code and then using a Java classloader and Java reflection to run the code and access its results.

  In more detail, a single compiler instance is used to accumulate all successfully compiled or interpreted Scala code. To "interpret" a line of code, the compiler generates a fresh object that includes the line of code and which has public member(s) to export all variables defined by that code. To extract the result of an interpreted line to show the user, a second "result object" is created which imports the variables exported by the above object and then exports members called "$eval" and "$print". To accommodate user expressions that read from variables or methods defined in previous statements, "import" statements are used.

  This interpreter shares the strengths and weaknesses of using the full compiler-to-Java. The main strength is that interpreted code behaves exactly as does compiled code, including running at full speed. The main weakness is that redefining classes and methods is not handled properly, because rebinding at the Java level is technically difficult.

  Definition Classes
    interpreter
-  object parse

  Parse a line into and return parsing result (error, incomplete or success with list of trees)

  Parse a line into and return parsing result (error, incomplete or success with list of trees)

  Definition Classes
    IMain
- Error
- Incomplete
- Result
- Success

c

scala.tools.nsc.interpreter.IMain.parse

# Error 

###

#### case class Error(trees: List[Global.Tree]) extends Result with Product with Serializable

Source
  IMain.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, Result, AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Error
2. Serializable
3. Serializable
4. Product
5. Equals
6. Result
7. AnyRef
8. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Error(trees: List[Global.Tree])

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Error to any2stringadd[Error] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Error, B)
   Implicit
     This member is added by an implicit conversion from Error to ArrowAssoc[Error] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
8.  def ensuring(cond: (Error) ⇒ Boolean, msg: ⇒ Any): Error
   Implicit
     This member is added by an implicit conversion from Error to Ensuring[Error] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
9.  def ensuring(cond: (Error) ⇒ Boolean): Error
   Implicit
     This member is added by an implicit conversion from Error to Ensuring[Error] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: Boolean, msg: ⇒ Any): Error
    Implicit
      This member is added by an implicit conversion from Error to Ensuring[Error] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean): Error
    Implicit
      This member is added by an implicit conversion from Error to Ensuring[Error] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
14.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Error to StringFormat[Error] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
15.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
16.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
17.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
18.  final def notify(): Unit
    Definition Classes
      AnyRef
19.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
20.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
21.  val trees: List[Global.Tree]
    Definition Classes
      Error → Result
22.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
23.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
24.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
25.  def →[B](y: B): (Error, B)
    Implicit
      This member is added by an implicit conversion from Error to ArrowAssoc[Error] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from Result

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Error to any2stringadd[Error]

### Inherited by implicit conversion StringFormat from Error to StringFormat[Error]

### Inherited by implicit conversion Ensuring from Error to Ensuring[Error]

### Inherited by implicit conversion ArrowAssoc from Error to ArrowAssoc[Error]

### Ungrouped